REM    
REM  1:200000  1:1000000

'********     **********

'  
DECLARE SUB compute(Shir#, Dolg#, M#, V_P%)
DECLARE SUB ang_rad(X_s#, X_k#, Y_s#, Y_k#)
DECLARE SUB draw_kr(V_Kr%)
DECLARE SUB ramka(Uw#, V_Min%, V_M%, Pr_Dolg#)

'   , 
'   ,    
GLOBAL CONST a = 6378245 
GLOBAL CONST e = 0.081813334
GLOBAL x#, y#, dY#, X_ns#, Y_ns#, X_nk#, Y_nk#, X_vs#, Y_vs#, X_vk#, Y_vk#
GLOBAL y_o#, r#, ang#, R_n#, R_v#, Ang_n#, Ang_v#, Y_on#, Y_ov#, Kf#

'      
'     1:1000000
'   
DIM H#(0 TO 84)
	H#(0) = 4420400
	H#(4) = 4420900
	H#(8) = 4421800
	H#(12) = 4423100
	H#(16) = 4424900
	H#(20) = 4427000
	H#(24) = 4429400
	H#(28) = 4432200
	H#(32) = 4435100
	H#(36) = 4438300
	H#(40) = 4441500
	H#(44) = 4444800
	H#(48) = 4448100
	H#(52) = 4451300
	H#(56) = 4454400
	H#(60) = 4455500
	H#(64) = 4458600
	H#(68) = 4461300
	H#(72) = 4463600
	H#(76) = 4464000
	H#(80) = 4466100
	H#(84) = 4467400

'**********      ***********

'    
BEGIN DIALOG Dialog1 126, 83, " "
	OPTIONGROUP V_M%
		OPTIONBUTTON  19, 25, 47, 8, "1 : 200000"
		OPTIONBUTTON  19, 39, 47, 8, "1 : 1000000"
	GROUPBOX  8, 8, 111, 45, ""
	OKBUTTON  11, 64, 48, 15
	CANCELBUTTON  66, 64, 48, 15
END DIALOG

'      1:1000000
BEGIN DIALOG Dialog2 126, 83, " "
	OPTIONGROUP V_P%
		OPTIONBUTTON  19, 25, 90, 8, " "
		OPTIONBUTTON  19, 39, 76, 8, ""
	GROUPBOX  9, 8, 111, 45, ""
	OKBUTTON  11, 64, 48, 15
	CANCELBUTTON  66, 64, 48, 15
END DIALOG

'        1:1000000
BEGIN DIALOG Dialog3 138, 115, " "
	TEXT  18, 13, 57, 10, " "
	OKBUTTON  17, 92, 48, 16
	CANCELBUTTON  73, 92, 48, 16
	TEXTBOX  80, 12, 34, 13, S_N_Shir$
	TEXT  118, 9, 5, 8, ""
	TEXT  18, 32, 56, 10, ""
	TEXT  18, 41, 50, 8, " "
	TEXTBOX  80, 35, 34, 13, S_Pr_Dolg$
	TEXT  118, 32, 5, 8, ""
	CHECKBOX  11, 58, 113, 13, "  ", V_Min%
	CHECKBOX  11, 73, 113, 13, "   ", V_Kr%
END DIALOG

'        1:200000
BEGIN DIALOG Dialog4 139, 187, " "
	TEXT  58, 78, 57, 10, ""
	OKBUTTON  18, 164, 48, 16
	CANCELBUTTON  74, 164, 48, 16
	TEXTBOX  18, 77, 34, 13, Verh_s$
	TEXT  58, 98, 50, 8, ""
	TEXTBOX  18, 97, 34, 13, Niz_s$
	CHECKBOX  13, 145, 113, 13, "   ", V_Kr%
	GROUPBOX  12, 60, 115, 77, " "
	TEXT  58, 118, 50, 8, ""
	TEXTBOX  18, 117, 34, 13, Bock_s$
	TEXTBOX  18, 40, 34, 13, Kf_s$
	TEXT  58, 41, 50, 8, ""
	GROUPBOX  12, 6, 115, 29, " "
	TEXTBOX  18, 18, 34, 13, S_N_Shir$
END DIALOG


'********************************************************
'*********   ***************************
'********************************************************


'*********     **************

'     
ret = DIALOG(Dialog1)
IF CANCEL THEN STOP
IF V_M% = 0 THEN 
	'  1:200000
	M# = 1 / 200000
	'         1:200000
	ret = DIALOG(Dialog4)
	IF CANCEL THEN STOP
	Verh_s1$ = LEFT(Verh_s$, INSTR(Verh_s$, ",")-1)
	Verh# = VAL(Verh_s1$) + VAL(RIGHT(Verh_s$, LEN(Verh_s$) - INSTR(Verh_s$, ","))) / 10^(LEN(Verh_s$) - LEN(Verh_s1$) - 1)
	Niz_s1$ = LEFT(Niz_s$, INSTR(Niz_s$, ",")-1)
	Niz# = VAL(Niz_s1$) + VAL(RIGHT(Niz_s$, LEN(Niz_s$) - INSTR(Niz_s$, ","))) / 10^(LEN(Niz_s$) - LEN(Niz_s1$) - 1)
	Bock_s1$ = LEFT(Bock_s$, INSTR(Bock_s$, ",")-1)
	Bock# = VAL(Bock_s1$) + VAL(RIGHT(Bock_s$, LEN(Bock_s$) - INSTR(Bock_s$, ","))) / 10^(LEN(Bock_s$) - LEN(Bock_s1$) - 1)
	Kf_s1$ = LEFT(Kf_s$, INSTR(Kf_s$, ",")-1)
	Kf# = VAL(Kf_s1$) + VAL(RIGHT(Kf_s$, LEN(Kf_s$) - INSTR(Kf_s$, ","))) / 10^(LEN(Kf_s$) - LEN(Kf_s1$) - 1)
	V_Min% = 1
	S_N_Shir_Gr$ = LEFT(S_N_Shir$, INSTR(S_N_Shir$, ",")-1)
	S_N_Shir_Min$ = RIGHT(S_N_Shir$, LEN(S_N_Shir$) - INSTR(S_N_Shir$, ","))
	N_Shir# = VAL(S_N_Shir_Gr$) + VAL(S_N_Shir_Min$) / 60
	Pr_Dolg# = 1
	IF Kf > 0 THEN Pr_Dolg# = 1 * Kf
	Pr_Shir# = 40 / 60
ELSE
	'  1:1000000
	M# = 1 / 1000000
	'       1:1000000
	ret = DIALOG(Dialog2)
	IF CANCEL THEN STOP	
	'         1:1000000
	ret = DIALOG(Dialog3)
	IF CANCEL THEN STOP	
	N_Shir# = VAL(S_N_Shir$)
	Pr_Dolg# = VAL(S_Pr_Dolg$)
	Pr_Shir# = 4
ENDIF

'*********     ********

IF V_P = 0 THEN
	'      :
	'    
	Shir# = N_Shir
	Dolg# = 0
	CALL compute(Shir, Dolg, M, V_P)
	X_ns = 0
	Y_ns = y
	'     
	Shir = N_Shir + Pr_Shir
	Dolg = Pr_Dolg / 2
	CALL compute(Shir, Dolg, M, V_P)
	'   ,      
	dY# = (y + Y_ns) / 2
	Y_ns = Y_ns - dY
	X_vk = x
	Y_vk = y - dY
	'     
	Shir = N_Shir
	Dolg = Pr_Dolg / 2
	CALL compute(Shir, Dolg, M, V_P%)
	X_nk = x
	Y_nk = y - dY
	'    
	Shir = N_Shir + Pr_Shir
	Dolg = 0
	CALL compute(Shir, Dolg, M, V_P)
	X_vs = 0
	Y_vs = y - dY
	IF V_M = 0 THEN
		Y_temp = Y_vk - Y_nk
		X_nk = Niz * 5000
		X_vk = Verh * 5000
		Y_temp1 = SQR((Bock * 10000)^2 - (X_nk - X_vk)^2)
		Y_temp = (Y_temp1 - Y_temp) / 2
		Y_nk = Y_nk - Y_temp
		Y_vk = Y_vk + Y_temp
		Y_ns = Y_ns - Y_temp
		Y_vs = Y_vs + Y_temp
	ENDIF
ELSE
	'      :
	'   ,      
	Shir = N_Shir + Pr_Shir
	Dolg = Pr_Dolg / 2
	CALL compute(Shir, Dolg, M, V_P)
	dY# = (H(N_Shir) + y) / 2
	'    
	X_ns = 0
	Y_ns = -dY
	'     
	X_vk = x
	Y_vk = dY
	'     
	Shir = N_Shir
	Dolg = Pr_Dolg / 2
	CALL compute(Shir, Dolg, M, V_P%)
	X_nk = x
	Y_nk = -dY + y
	'    
	Shir = N_Shir + Pr_Shir
	Dolg = Pr_Dolg / 2
	CALL compute(Shir, Dolg, M, V_P)
	X_vs = 0
	Y_vs = dY - y
ENDIF

REM par_1# = INT(X_vk * 2) / 10000
REM par_2# = INT(X_nk * 2) / 10000
REM par_3# = INT(SQR((X_nk - X_vk)^2 + (Y_vk - Y_nk)^2)) / 10000
REM par_4# = INT(SQR((X_nk + X_vk)^2 + (Y_vk - Y_nk)^2)) / 10000
REM I1$ = "  - " + STR(par_1) + CHR(13) + CHR(10)
REM I2$ = "  - " + STR(par_2) + CHR(13) + CHR(10)
REM I3$ = "  - " + STR(par_3) + CHR(13) + CHR(10)
REM I4$ = " - " + STR(par_4) + CHR(13) + CHR(10)
REM 
REM Inf% = MESSAGEBOX(I1 + I2 + I3 + I4, "", 0 OR 64)

'*********     ********

' :
CALL ang_rad(X_ns, X_nk, Y_ns, Y_nk)
' 
Y_on# = Y_o
'
R_n = r
' 
Ang_n = ang

' :
CALL ang_rad(X_vs, X_vk, Y_vs, Y_vk)
' 
Y_ov# = Y_o
'
R_v = r
' 
Ang_v = ang



'**********  ************

WITHOBJECT DRAW

	'   ""
	'(        )
	.NewLayer ""

	IF V_M = 1 THEN
		'     1:1000000

		'  
		'   
		CALL ramka(0, V_Min, V_M%, Pr_Dolg)
		IDRect& = .GetObjectsCDRStaticID()
		'  
		CALL ramka(94800, V_Min, V_M%, Pr_Dolg)
		'    
		'  
		.SelectObjectOfCDRStaticID IDRect&
		.Combine
		'     
		.ApplyOutline 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		.ApplyUniformFillColor 2, 0, 0, 0, 0
		'  
		CALL ramka(9200, V_Min, V_M%, Pr_Dolg)
		'    
		CALL ramka(94800, V_Min, V_M%, Pr_Dolg)
		.ApplyOutline 1600, 1, 0, 0, 100, 0, 0, 0, 0, 0
		.SetOutlineColor 2, 0, 0, 0, 100
		.ApplyNoFill
		CALL ramka(85600, V_Min, V_M%, Pr_Dolg)
		.ApplyOutline 7000, 1, 0, 0, 100, 0, 0, 0, 0, 0
		.SetOutlineColor 2, 0, 0, 0, 100
		.ApplyNoFill
		CALL ramka(76400, V_Min, V_M%, Pr_Dolg)
		.ApplyOutline 1600, 1, 0, 0, 100, 0, 0, 0, 0, 0
		.SetOutlineColor 2, 0, 0, 0, 100
		.ApplyNoFill
		'     
		CALL draw_kr(V_Kr)

	ELSE
		'     1:200000

		'  
		'   
		CALL ramka(0, V_Min, V_M%, Pr_Dolg)
		IDRect& = .GetObjectsCDRStaticID()
		'  
		CALL ramka(90800, V_Min, V_M%, Pr_Dolg)
		'    
		'  
		.SelectObjectOfCDRStaticID IDRect&
		.Combine
		'     
		.ApplyOutline 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		.ApplyUniformFillColor 2, 0, 0, 0, 0
		'   
		CALL ramka(77200, V_Min, V_M%, Pr_Dolg)
		'   
		CALL ramka(68000, V_Min, V_M%, Pr_Dolg)
		.ApplyOutline 1200, 1, 0, 0, 100, 0, 0, 0, 0, 0
		.SetOutlineColor 2, 0, 0, 0, 100
		.ApplyNoFill
		'    
		CALL ramka(90800, V_Min, V_M%, Pr_Dolg)
		.ApplyOutline 10000, 1, 0, 0, 100, 0, 0, 0, 0, 0
		.SetOutlineColor 2, 0, 0, 0, 100
		.ApplyNoFill
		'     
		CALL draw_kr(V_Kr)
	ENDIF

END WITHOBJECT
STOP



'*********    **********

'   
' 

SUB compute(Shir#, Dolg#, M#, V_P%)

	CONST B_1 = 6367558.5
	CONST B_2 = 32005.8
	CONST B_3 = 133.92
	CONST B_4 = 0.7

	Shir# = ANGLECONVERT(1, 2, Shir#)
	Dolg# = ANGLECONVERT(1, 2, Dolg#)
	Dolg_o# = 0
	N# = a / SQR(1 - e^2 * SIN(Shir)^2)
	IF V_P = 1 THEN
		'    
		'  
		y = N / TAN(Shir) * (1 - COS(Dolg * SIN(Shir))) * 10
		x = N / TAN(Shir) * SIN(Dolg * SIN(Shir)) * 10
	ELSE
		'    
		'  
		X_# = B_1 * Shir - SIN(Shir) * COS(Shir) * (B_2 + SIN(Shir)^2 * (B_3 + B_4 * SIN(Shir)))
		l# = Dolg - Dolg_o
		Psi# = l * COS(Shir)
		a2# = 1 / 2 * N * SIN(Shir) * COS(Shir)
		a4# = 1 / 24 * N * COS(Shir)^3 * SIN(Shir) * (5 - TAN(Shir)^2 + 9 * Psi^2 + 4 * Psi^4)
		a6# = 1 / 720 * N * SIN(Shir) * COS(Shir)^5 * (61 - 58 * TAN(Shir)^2 + TAN(Shir)^4)
		b1# = N * COS(Shir)
		b3# = 1 / 6 * N * COS(Shir)^3 * (1 - TAN(Shir)^2 + Psi^2)
		b5# = N / 120 * COS(Shir)^5 * (5 - 18 * TAN(Shir)^2 + TAN(Shir)^4 + 14 * Psi^2 - 58 * Psi^2 * TAN(Shir)^3)
		y = M * (X_ + a2 * l^2 + a4 * l^4 + a6 * l^6) * 10000000
		x = M * (b1 * l + b3 * l^3 + b5 * l^5) * 10000000
	ENDIF

END SUB

'     

SUB ang_rad(X_s#, X_k#, Y_s#, Y_k#)

	y_o = (X_s^2 - X_k^2 + Y_s^2 - Y_k^2) / (2 * (Y_s - Y_k))
	r = SQR(X_s^2 + (Y_s - Y_o)^2)
	ang = ASIN((X_k - X_s) / r)

END SUB

'      

SUB draw_kr(V_Kr%)

	IF V_Kr = 1 THEN
		WITHOBJECT DRAW
			.NewLayer "  "
			Y_kr& = Y_ns# - 950000
			DO WHILE Y_kr < Y_vk#
				Y_kr = Y_kr + 800000
				X_kr& = -X_nk# - 150000
				DO WHILE X_kr < X_nk# + 750000
					.BeginDrawCurve X_kr, Y_kr
					.DrawCurveLineTo X_kr + 100000, Y_kr
					.DrawCurveMoveTo X_kr + 50000, Y_kr - 50000
					.DrawCurveLineTo X_kr + 50000, Y_kr + 50000
					.EndDrawCurve
					.ApplyOutline 200, 1, 0, 0, 100, 0, 0, 0, 0, 0
					.SetOutlineColor 2, 0, 0, 0, 100
					X_kr = X_kr + 800000
				LOOP
			LOOP
			.SelectLayer ""
		END WITHOBJECT
	ENDIF

END SUB

'  

SUB ramka(Uw#, V_Min%, V_M%, Pr_Dolg#)

	WITHOBJECT DRAW
    
		'     .
		'      
		' ,  
		'   ,   .
		'  :
		'Y = Y_pr + k * (X - X_pr).
		'  :
		'Y = Y_ov + SQR((R_v - Uw)^2 - (X - X_ov)^2).
	
		'  :
		'    
		k# = (Y_vk - Y_nk) / (X_vk - X_nk)
		Ang_pr# = ATAN(k)
		' X  Y     
		X_pr# = X_nk - Uw * SIN(Ang_pr#)
		Y_pr# = Y_nk + Uw * COS(Ang_pr#)
		'  
		z# = Y_pr - k * X_pr - Y_ov
		D# = SQR((k * z)^2 - (k^2 + 1) * (z^2 - (R_v - Uw)^2))
		
		' Y      X 
		'   
		X_pv# = (-k * z + D) / (k^2 + 1)
		'     Y
		'   
		Y_pv# = Y_pr + k * (X_pv - X_pr)
		'     
		Ang_vo# = ASIN(X_pv / (R_v - Uw))    
		
		'     
		' ,      .
		
		'  
		z# = Y_pr - k * X_pr - Y_on
		D# = SQR((k * z)^2 - (k^2 + 1) * (z^2 - (R_n + Uw)^2))
	
		' Y      X 
		'   
		X_pn# = (-k * z + D) / (k^2 + 1)
		'     Y
		'   
		Y_pn# = Y_pr + k * (X_pn - X_pr)
		'     
		Ang_no# = ASIN(X_pn / (R_n + Uw))    
		
		' .
		IF V_M = 0 THEN 
			K_Del_G% = 60 * Kf
			K_Del_V% = 40
		ELSE
			K_Del_G% = Pr_Dolg * 6
			K_Del_V% = 24
		ENDIF
		.BeginDrawCurve X_pv, Y_pv
		'     K_Del_G 
		FOR I% = 1 TO K_Del_G
			Xi# = (R_v - Uw) * SIN(Ang_vo - I * Ang_vo / K_Del_G * 2)
			Yi# = Y_ov - (R_v - Uw) * COS(Ang_vo - I * Ang_vo / K_Del_G * 2)
			.DrawCurveLineTo Xi, Yi
		NEXT I%
		'  
		.DrawCurveLineTo -X_pn#, Y_pn#
		'     K_Del_G  
		FOR I% = 1 TO K_Del_G
			Xi = -(R_n + Uw) * SIN(Ang_no - I * Ang_no / K_Del_G * 2)
			Yi = Y_on - (R_n + Uw) * COS(Ang_no - I * Ang_no / K_Del_G * 2)
			.DrawCurveLineTo Xi, Yi
		NEXT I%
		'  
		.DrawCurveClosePath
		.EndDrawCurve
		    
		IF (Uw = 9200) OR (Uw = 77200) THEN
			'   
			'   0.12 
			.ApplyOutline 1200, 1, 0, 0, 100, 0, 0, 0, 0, 0
			.SetOutlineColor 2, 0, 0, 0, 100
			.ApplyNoFill
			IF V_Min = 1 THEN
				' ,   
				'    
				FOR I% = 0 TO K_Del_G
					X1# = -(R_v - Uw) * SIN(Ang_v - I * Ang_v / K_Del_G * 2)
					X2# = -(R_v - Uw + 4600) * SIN(Ang_v - I * Ang_v / K_Del_G * 2)
					X3# = -(R_v - Uw + 9200) * SIN(Ang_v - I% * Ang_v / K_Del_G * 2)
					X4# = -(R_n + Uw - 9200) * SIN(Ang_n - I * Ang_n / K_Del_G * 2)
					X5# = -(R_n + Uw - 4600) * SIN(Ang_n - I * Ang_n / K_Del_G * 2)
					X6# = -(R_n + Uw) * SIN(Ang_n - I * Ang_n / K_Del_G * 2)
					Y1# = Y_ov - (R_v - Uw) * COS(Ang_v - I * Ang_v / K_Del_G * 2)
					Y2# = Y_ov - (R_v - Uw + 4600) * COS(Ang_v - I * Ang_v / K_Del_G * 2)
					Y3# = Y_ov - (R_v - Uw + 9200) * COS(Ang_v - I * Ang_v / K_Del_G * 2)
					Y4# = Y_on - (R_n + Uw - 9200) * COS(Ang_n - I * Ang_n / K_Del_G * 2)
					Y5# = Y_on - (R_n + Uw - 4600) * COS(Ang_n - I * Ang_n / K_Del_G * 2)
					Y6# = Y_on - (R_n + Uw) * COS(Ang_n - I * Ang_n / K_Del_G * 2)
					IF I = 0 THEN	.BeginDrawCurve X1, Y1
					IF (I MOD 2 = 0) AND (I < K_Del_G) THEN
						X7# = -(R_v - Uw + 4600) * SIN(Ang_v - (I + 1) * Ang_v / K_Del_G * 2)
						X8# = -(R_n + Uw - 4600) * SIN(Ang_n - (I + 1) * Ang_n / K_Del_G * 2)
						Y7# = Y_ov - (R_v - Uw + 4600) * COS(Ang_v - (I + 1) * Ang_v / K_Del_G * 2)
						Y8# = Y_on - (R_n + Uw - 4600) * COS(Ang_n - (I + 1) * Ang_n / K_Del_G * 2)
						.DrawCurveMoveTo X1, Y1
						.DrawCurveLineTo X3, Y3
						.DrawCurveMoveTo X2, Y2
						.DrawCurveLineTo X7, Y7
						.DrawCurveMoveTo X4, Y4
						.DrawCurveLineTo X6, Y6
						.DrawCurveMoveTo X5, Y5
						.DrawCurveLineTo X8, Y8
					ELSE
						.DrawCurveMoveTo X1, Y1
						.DrawCurveLineTo X3, Y3
						.DrawCurveMoveTo X4, Y4
						.DrawCurveLineTo X6, Y6
					ENDIF
	
					' 
					IF V_M = 0 THEN
						IF I MOD 15 = 0 THEN
							.DrawCurveMoveTo X3, Y3
							.DrawCurveLineTo X4, Y4
						ENDIF
					ELSE
						IF I MOD 6 = 0 THEN
							.DrawCurveMoveTo X3, Y3
							.DrawCurveLineTo X4, Y4
						ENDIF
					ENDIF
				NEXT I%
				.EndDrawCurve
				'    0.12 
				.ApplyOutline 1200, 1, 0, 0, 100, 0, 0, 0, 0, 0
				.SetOutlineColor 2, 0, 0, 0, 100
	
				'  
				'  :
				' X  Y     
				X_pr1# = X_nk - (Uw - 9200) * SIN(Ang_pr#)
				Y_pr1# = Y_nk + (Uw - 9200) * COS(Ang_pr#)
				'  
				z# = Y_pr1 - k * X_pr1 - Y_ov
				D# = SQR((k * z)^2 - (k^2 + 1) * (z^2 - (R_v - (Uw - 9200))^2))
	
				' Y      X 
				'   
				X_pv1# = (-k * z + D) / (k^2 + 1)
				'     Y
				'   
				Y_pv1# = Y_pr1 + k * (X_pv1 - X_pr1)
	
				'     
				' ,      .
	
				'  
				z# = Y_pr1 - k * X_pr1 - Y_on
				D# = SQR((k * z)^2 - (k^2 + 1) * (z^2 - (R_n + (Uw - 9200))^2))
	
				' Y      X 
				'   
				X_pn1# = (-k * z + D) / (k^2 + 1)
				'     Y
				'   
				Y_pn1# = Y_pr1 + k * (X_pn1 - X_pr1)

				FOR I% = 0 TO K_Del_V
					X1# = -X_pn + Uw * COS(-Ang_pr) + (-X_pv + X_pn - 2 * Uw * COS(-Ang_pr)) / K_Del_V * I
					X3# = -X_pn1 + (Uw - 9200) * COS(-Ang_pr) + (-X_pv1 + X_pn1 - 2 * (Uw - 9200) * COS(-Ang_pr)) / K_Del_V * I
					X2# = (X1 + X3) / 2
					X4# = X_pn1 - (Uw - 9200) * COS(Ang_pr) + (X_pv1 - X_pn1 + 2 * (Uw - 9200) * COS(Ang_pr)) / K_Del_V * I
					X6# = X_pn - Uw * COS(Ang_pr) + (X_pv - X_pn + 2 * Uw * COS(Ang_pr)) / K_Del_V * I
					X5# = (X4 + X6) / 2
					Y1# = Y_pn - Uw * SIN(Ang_pr) + (Y_pv - Y_pn + 2 * Uw * SIN(Ang_pr)) / K_Del_V * I
					Y3# = Y_pn1 - (Uw - 9200) * SIN(Ang_pr) + (Y_pv1 - Y_pn1 + 2 * (Uw - 9200) * SIN(Ang_pr)) / K_Del_V * I
					Y2# = (Y1 + Y3) / 2
					Y4# = Y_pn1 - (Uw - 9200) * SIN(Ang_pr) + (Y_pv1 - Y_pn1 + 2 * (Uw - 9200) * SIN(Ang_pr)) / K_Del_V * I
					Y6# = Y_pn - Uw * SIN(Ang_pr) + (Y_pv - Y_pn + 2 * Uw * SIN(Ang_pr)) / K_Del_V * I
					Y5# = (Y6 + Y4) / 2
					IF I = 0 THEN	.BeginDrawCurve X1, Y1
					IF I MOD 2 = 0 THEN
						X7# = X2
						X8# = X5
						Y7# = Y2
						Y8# = Y5
						.DrawCurveMoveTo X1, Y1
						.DrawCurveLineTo X3, Y3
						.DrawCurveMoveTo X4, Y4
						.DrawCurveLineTo X6, Y6
					ELSE
						.DrawCurveMoveTo X1, Y1
						.DrawCurveLineTo X3, Y3
						.DrawCurveMoveTo X2, Y2
						.DrawCurveLineTo X7, Y7
						.DrawCurveMoveTo X4, Y4
						.DrawCurveLineTo X6, Y6
						.DrawCurveMoveTo X5, Y5
						.DrawCurveLineTo X8, Y8
					ENDIF
					IF ((V_M = 0) AND (I MOD 10 = 0)) OR ((V_M = 1) AND (I MOD 4 = 0))THEN
						.DrawCurveMoveTo X3, Y3
						'   K_Del_G 
						FOR J% = 1 TO K_Del_G
							X_iv# = R_v * SIN(-Ang_v + J * Ang_v / K_Del_G * 2)
							Y_iv# = Y_ov - R_v * COS(Ang_v - J * Ang_v / K_Del_G * 2)
							X_in# = -R_n * SIN(Ang_n - J * Ang_n / K_Del_G * 2)
							Y_in# = Y_on - R_n * COS(Ang_n - J * Ang_n / K_Del_G * 2)
							Xi = X_in + (X_iv -X_in) / K_Del_V * I
							Yi = Y_in + (Y_iv - Y_in) / K_Del_V * I
							.DrawCurveLineTo Xi, Yi
						NEXT J%
						.DrawCurveLineTo X4, Y4
					ENDIF
				NEXT I%
				.EndDrawCurve
				'    0.12 
				.ApplyOutline 1200, 1, 0, 0, 100, 0, 0, 0, 0, 0
				.SetOutlineColor 2, 0, 0, 0, 100
			ELSE
				.DeleteObject
				FOR I% = 0 TO Pr_Dolg
					X1# = -R_v * SIN(Ang_v - I% * Ang_v / Pr_Dolg * 2)
					X2# = -R_n * SIN(Ang_n - I * Ang_n / Pr_Dolg * 2)
					Y1# = Y_ov - R_v * COS(Ang_v - I * Ang_v / Pr_Dolg * 2)
					Y2# = Y_on - R_n * COS(Ang_n - I * Ang_n / Pr_Dolg * 2)
					IF I = 0 THEN .BeginDrawCurve X1, Y1
					.DrawCurveMoveTo X1, Y1
					.DrawCurveLineTo X2, Y2
				NEXT I%
				.EndDrawCurve
				'    0.12 
				.ApplyOutline 1200, 1, 0, 0, 100, 0, 0, 0, 0, 0
				.SetOutlineColor 2, 0, 0, 0, 100
				FOR I% = 0 TO 6
					'   Pr_Dolg * 6 
					FOR J% = 0 TO Pr_Dolg * 6
						X_iv# = R_v * SIN(-Ang_v + J * Ang_v / Pr_Dolg / 3)
						Y_iv# = Y_ov - R_v * COS(Ang_v - J * Ang_v / Pr_Dolg / 3)
						X_in# = -R_n * SIN(Ang_n - J * Ang_n / Pr_Dolg / 3)
						Y_in# = Y_on - R_n * COS(Ang_n - J * Ang_n / Pr_Dolg / 3)
						Xi = X_in + (X_iv -X_in) / 6 * I
						Yi = Y_in + (Y_iv - Y_in) / 6 * I
						IF J = 0 THEN 
							IF I = 0 THEN .BeginDrawCurve X_iv, Y_iv
							.DrawCurveMoveTo X_iv, Y_iv
						ENDIF
						.DrawCurveLineTo Xi, Yi
					NEXT J%
				NEXT I%
				.EndDrawCurve
				'    0.12 
				.ApplyOutline 1200, 1, 0, 0, 100, 0, 0, 0, 0, 0
				.SetOutlineColor 2, 0, 0, 0, 100
			ENDIF
		ENDIF
	
	END WITHOBJECT

END SUB

